package wrapper;

/**Data structure used to report invocation status. */
public class InvocationStatus {
  /**Id of the invocation this status report is for.*/
  final Integer invocationId;
  /**Status of the invocation. Possible values are: <br>
  DONE: computation has finished, all results are ready and have final values<br>
  NOT_DONE: computation is still going on, no results yet available<br>
  PARTIAL: computation is still going on, preliminary results are available<br>
  ERROR: computation aborted before finishing*/
  String status; //"NOT_DONE", "DONE", "ERROR", "PARTIAL"
  /**Progress of the invocation. If -1, then no progress has yet been reported.*/
  float progress = -1;

  InvocationStatus(Integer invocationId) {
    this.invocationId = invocationId;
  }
  
}